public class Main {
    public static class Crypto {
        public Crypto() {
            sm = cnt = 0;
            seed();
        }
        public int decode(int z) {
            z ^= next();
            z ^= (next() << 8);
            z ^= (next() << 16);
            z ^= (next() << 22);
            return z;
        }
        public void query(long z) {
            final long B = 425481007;
            final long MD = 1000000007;
            cnt++;
            sm = ((sm * B % MD + z) % MD + MD) % MD;
            seed();
        }

        long sm;
        int cnt;
        
        byte data[] = new byte[256];
        int I, J;

        int asUint(byte x) {
            int y = x;
            return y & 0xff;
        }
        void seed() {
            byte key[] = new byte[8];
            for (int i = 0; i < 4; i++) {
                key[i] = (byte)(sm >>> (i * 8));
            }
            for (int i = 0; i < 4; i++) {
                key[i+4] = (byte)(cnt >>> (i * 8));
            }

            for (int i = 0; i < 256; i++) {
                data[i] = (byte)i;
            }
            I = J = 0;

            int j = 0;
            for (int i = 0; i < 256; i++) {
                j = (j + asUint(data[i]) + asUint(key[i % 8])) % 256;
                byte tmp = data[i];
                data[i] = data[j];
                data[j] = tmp;
            }
        }
        int next() {
            I = (I+1) % 256;
            J = (J+asUint(data[I])) % 256;
            byte tmp = data[I];
            data[I] = data[J];
            data[J] = tmp;
            return asUint(data[(asUint(data[I]) + asUint(data[J])) % 256]);
        }
    }
    public static void main(String[] args) {
        ...
    }
}
